Bug 1366739 - additionally added rimage/rmeta sublvs during take over should match: "_rimage_n" and "_rmeta_n"
Summary: additionally added rimage/rmeta sublvs during take over should match: "_rimag...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: lvm2
Version: 7.3
Hardware: x86_64
OS: Linux
unspecified
medium
Target Milestone: rc
: ---
Assignee: LVM and device-mapper development team
QA Contact: cluster-qe@redhat.com
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-08-12 16:31 UTC by Corey Marthaler
Modified: 2016-11-04 04:17 UTC (History)
8 users (show)

Fixed In Version: lvm2-2.02.164-2.el7
Doc Type: No Doc Update
Doc Text:
Intra-release bug, no documentation needed.
Clone Of:
Environment:
Last Closed: 2016-11-04 04:17:15 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2016:1445 normal SHIPPED_LIVE lvm2 bug fix and enhancement update 2016-11-03 13:46:41 UTC

Description Corey Marthaler 2016-08-12 16:31:21 UTC
Description of problem:
This is the third issue listed in:
https://bugzilla.redhat.com/show_bug.cgi?id=1191630#c6


[root@host-082 ~]# lvs -a -o +devices
  LV                   VG   Attr       LSize  Devices                                    
  transform            test rwi-a-r--- 32.00m transform_rimage_0(0),transform_rimage_1(0)
  [transform_rimage_0] test iwi-aor--- 16.00m /dev/sda1(0)
  [transform_rimage_1] test iwi-aor--- 16.00m /dev/sdb1(0)

[root@host-082 ~]#
[root@host-082 ~]# lvconvert --type raid4 test/transform
  Using default stripesize 64.00 KiB.
  Logical volume test/transform successfully converted.

[root@host-082 ~]# lvs -a -o +devices
  LV                           VG   Attr       LSize   Cpy%Sync Devices
  transform                    test rwi-a-r--- 32.00m  100.00   transform_rimage_0(0),transform_rimage_1(0),transform_rimage_2(0)
  [transform_rimage_0]         test iwi-aor--- 16.00m           /dev/sda1(0)
  [transform_rimage_0_rmeta_0] test ewi-aor---  4.00m           /dev/sda1(4)
  [transform_rimage_1]         test iwi-aor--- 16.00m           /dev/sdb1(0)
  [transform_rimage_1_rmeta_0] test ewi-aor---  4.00m           /dev/sda1(5)
  [transform_rimage_2]         test iwi-aor--- 16.00m           /dev/sdc1(1)
  [transform_rmeta_0]          test ewi-aor---  4.00m           /dev/sdc1(0) <- This should be named "_rmeta_2" since it cooresponds to _rimage_2

For comparison, this is what a "proper" raid4 layout should look like:
  transform            test rwi-a-r---  32.00m  100.00  transform_rimage_0(0),transform_rimage_1(0),transform_rimage_2(0)
  [transform_rimage_0] test iwi-aor---  16.00m          /dev/sda1(1)
  [transform_rimage_1] test iwi-aor---  16.00m          /dev/sdb1(1)
  [transform_rimage_2] test iwi-aor---  16.00m          /dev/sdc1(1)
  [transform_rmeta_0]  test ewi-aor---   4.00m          /dev/sda1(0)
  [transform_rmeta_1]  test ewi-aor---   4.00m          /dev/sdb1(0)
  [transform_rmeta_2]  test ewi-aor---   4.00m          /dev/sdc1(0)


Version-Release number of selected component (if applicable):
3.10.0-489.el7.x86_64

lvm2-2.02.163-1.el7    BUILT: Wed Aug 10 06:53:21 CDT 2016
lvm2-libs-2.02.163-1.el7    BUILT: Wed Aug 10 06:53:21 CDT 2016
lvm2-cluster-2.02.163-1.el7    BUILT: Wed Aug 10 06:53:21 CDT 2016
device-mapper-1.02.133-1.el7    BUILT: Wed Aug 10 06:53:21 CDT 2016
device-mapper-libs-1.02.133-1.el7    BUILT: Wed Aug 10 06:53:21 CDT 2016
device-mapper-event-1.02.133-1.el7    BUILT: Wed Aug 10 06:53:21 CDT 2016
device-mapper-event-libs-1.02.133-1.el7    BUILT: Wed Aug 10 06:53:21 CDT 2016
device-mapper-persistent-data-0.6.3-1.el7    BUILT: Fri Jul 22 05:29:13 CDT 2016
cmirror-2.02.163-1.el7    BUILT: Wed Aug 10 06:53:21 CDT 2016
sanlock-3.4.0-1.el7    BUILT: Fri Jun 10 11:41:03 CDT 2016
sanlock-lib-3.4.0-1.el7    BUILT: Fri Jun 10 11:41:03 CDT 2016
lvm2-lockd-2.02.163-1.el7    BUILT: Wed Aug 10 06:53:21 CDT 2016

Comment 2 Alasdair Kergon 2016-08-12 23:06:05 UTC
Same as bug 1366737.  (It's simply picking the first unused rimage number and the first unused rmeta number.)

The double suffix on the internal rmeta LVs is just cosmetic - fixed with 
  https://git.fedorahosted.org/cgit/lvm2.git/commit/
  https://www.redhat.com/archives/lvm-devel/2016-August/msg00063.html

Comment 4 Corey Marthaler 2016-08-17 22:25:42 UTC
Fix verified in the raid0 -> raid0_meta -> raid4 case.

3.10.0-493.el7.bz1367223.x86_64
lvm2-2.02.164-2.el7    BUILT: Tue Aug 16 05:43:50 CDT 2016
lvm2-libs-2.02.164-2.el7    BUILT: Tue Aug 16 05:43:50 CDT 2016
lvm2-cluster-2.02.164-2.el7    BUILT: Tue Aug 16 05:43:50 CDT 2016
device-mapper-1.02.133-2.el7    BUILT: Tue Aug 16 05:43:50 CDT 2016
device-mapper-libs-1.02.133-2.el7    BUILT: Tue Aug 16 05:43:50 CDT 2016
device-mapper-event-1.02.133-2.el7    BUILT: Tue Aug 16 05:43:50 CDT 2016
device-mapper-event-libs-1.02.133-2.el7    BUILT: Tue Aug 16 05:43:50 CDT 2016
device-mapper-persistent-data-0.6.3-1.el7    BUILT: Fri Jul 22 05:29:13 CDT 2016
cmirror-2.02.164-2.el7    BUILT: Tue Aug 16 05:43:50 CDT 2016
sanlock-3.4.0-1.el7    BUILT: Fri Jun 10 11:41:03 CDT 2016
sanlock-lib-3.4.0-1.el7    BUILT: Fri Jun 10 11:41:03 CDT 2016
lvm2-lockd-2.02.164-2.el7    BUILT: Tue Aug 16 05:43:50 CDT 2016



[root@host-122 ~]# lvcreate --type raid0 -i 2 -L 32M -n lv transform
  Using default stripesize 64.00 KiB.
  Logical volume "lv" created.

[root@host-122 ~]# lvs -a -o +devices
  LV            VG         Attr       LSize   Devices
  lv            transform  rwi-a-r--- 32.00m  lv_rimage_0(0),lv_rimage_1(0)
  [lv_rimage_0] transform  iwi-aor--- 16.00m  /dev/sda1(0)
  [lv_rimage_1] transform  iwi-aor--- 16.00m  /dev/sdb1(0)

[root@host-122 ~]# lvconvert --type raid0_meta transform/lv
  Logical volume transform/lv successfully converted.

[root@host-122 ~]# lvs -a -o +devices
  LV            VG         Attr       LSize   Devices
  lv            transform  rwi-a-r--- 32.00m  lv_rimage_0(0),lv_rimage_1(0)
  [lv_rimage_0] transform  iwi-aor--- 16.00m  /dev/sda1(0)
  [lv_rimage_1] transform  iwi-aor--- 16.00m  /dev/sdb1(0)
  [lv_rmeta_0]  transform  ewi-aor---  4.00m  /dev/sda1(4)
  [lv_rmeta_1]  transform  ewi-aor---  4.00m  /dev/sdb1(4)

[root@host-122 ~]# lvconvert --type raid4 transform/lv
  Using default stripesize 64.00 KiB.
  Logical volume transform/lv successfully converted.

[root@host-122 ~]# lvs -a -o +devices
  LV            VG         Attr       LSize  Cpy%Sync Devices
  lv            transform  rwi-a-r--- 32.00m 100.00   lv_rimage_0(0),lv_rimage_1(0),lv_rimage_2(0)
  [lv_rimage_0] transform  iwi-aor--- 16.00m          /dev/sda1(0)
  [lv_rimage_1] transform  iwi-aor--- 16.00m          /dev/sdb1(0)
  [lv_rimage_2] transform  iwi-aor--- 16.00m          /dev/sdc1(1)
  [lv_rmeta_0]  transform  ewi-aor---  4.00m          /dev/sda1(4)
  [lv_rmeta_1]  transform  ewi-aor---  4.00m          /dev/sdb1(4)
  [lv_rmeta_2]  transform  ewi-aor---  4.00m          /dev/sdc1(0)

Comment 6 errata-xmlrpc 2016-11-04 04:17:15 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHBA-2016-1445.html


Note You need to log in before you can comment on or make changes to this bug.